.686
.mmx
.model flat, stdcall
	option casemap:none
	
	include \masm32\include\windows.inc
	
	include \masm32\include\masm32.inc
	includelib	\masm32\lib\masm32.lib

	include \masm32\include\kernel32.inc
	includelib	\masm32\lib\kernel32.lib
	
	include	\masm32\include\msvcrt.inc
	includelib	\masm32\lib\msvcrt.lib
	
	include	\masm32\macros\timers.asm
	include \masm32\macros\macros.asm
	
	EXTERNDEF hex_table :DWORD


.data
	str_dw2h_1	db	8 dup (0),0
	str_dw2h_2	db	8 dup (0),0

.code

m_mmx_dw2hex	macro	Value:REQ, lpBuffer
	LOCAL	mmx_dw2hex_buffer
	IFNDEF	mmx_dw2hex_enabled
		mmx_dw2hex_enabled	equ <1>
		.data
			align 8
			_mmx_dw2hex_isomsk	db 8 dup (0Fh)
			_mmx_dw2hex_cmpmsk	db 8 dup (0Ah)
			_mmx_dw2hex_ashmsk	db 8 dup (07h)
			_mmx_dw2hex_ascmsk	db 8 dup (30h)
			_mmx_dw2hex_buffer	db 8 dup (0),0
			align 4
	ENDIF
	
		.code
			align 2
			mov			eax, [Value]
			bswap       eax
			movd        mm0, eax
			movd        mm1, eax
			psrlw       mm0, 4
			punpcklbw   mm0, mm1
			pand        mm0, qword ptr [_mmx_dw2hex_isomsk]
			
			movq        mm1, qword ptr [_mmx_dw2hex_cmpmsk]
			pcmpgtb     mm1, mm0
			pandn       mm1, qword ptr [_mmx_dw2hex_ashmsk]
			paddb       mm0, qword ptr [_mmx_dw2hex_ascmsk]
			paddb       mm0, mm1
			
		IFB <lpBuffer>
			lea		eax, [_mmx_dw2hex_buffer]
			movq	qword ptr [eax],mm0
		ELSE
			mov		eax, [lpBuffer]
			movq	qword ptr [eax],mm0
		ENDIF
endm

mmx_dw2hexA	proc	;Value: EAX Buffer: EDX
	.data
		align 8
		mmx_dw2hex_isomsk	db 8 dup (0Fh)
		mmx_dw2hex_cmpmsk	db 8 dup (0Ah)
		mmx_dw2hex_ashmsk	db 8 dup (07h)
		mmx_dw2hex_ascmsk	db 8 dup (30h)
	
	.code
		bswap       eax         ;swap the bytes
		movd        mm0, eax
		movd        mm1, eax
		psrlw       mm0, 4
		punpcklbw   mm0, mm1    ;unpack & swap the nibble order
		pand        mm0, qword ptr [mmx_dw2hex_isomsk]
		
		movq        mm1, qword ptr [mmx_dw2hex_cmpmsk]  ;a mask that filters 0Ah~0Fh - (09)
		pcmpgtb     mm1, mm0                            ;apply the mask, the result is reversed
		pandn       mm1, qword ptr [mmx_dw2hex_ashmsk]  ;re-reverse the mask (NAND) - (07)
		paddb       mm0, qword ptr [mmx_dw2hex_ascmsk]  ;assign ASCII encoding
		paddb       mm0, mm1                            ;assign fixed ASCII encodeing
		
		movq        qword ptr [edx],mm0
		retn		
mmx_dw2hexA endp

;imported from the masm32 library
align 16

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

dw2hex_ex proc src:DWORD,buf:DWORD

    movzx ecx, BYTE PTR [esp+4]
    mov edx, DWORD PTR [ecx+ecx+hex_table]
    mov eax, [esp+8]                        ; load buffer address
    shl edx, 16
    movzx ecx, BYTE PTR [esp+5]
    mov dx, WORD PTR [ecx+ecx+hex_table]

    movzx ecx, BYTE PTR [esp+6]
    mov [eax+4], edx                        ; write 2nd DWORD
    mov ecx, DWORD PTR [ecx+ecx+hex_table]
    movzx edx, BYTE PTR [esp+7]
    shl ecx, 16
    mov cx, WORD PTR [edx+edx+hex_table]
    xor edx, edx
    mov [eax], ecx                          ; write 1st DWORD

    mov BYTE PTR [eax+8], dl

    ret 8

dw2hex_ex endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

start:
	push	ebp
	mov		ebp,esp
		;=======================
		loop_count	equ	10000000
		;=======================
		invoke	Sleep,1000
		
		counter_begin loop_count,HIGH_PRIORITY_CLASS
			mov		eax,01234568h
			mov		edx,offset str_dw2h_1
			call	mmx_dw2hexA
			mov		eax,9ABCDEF0h
			mov		edx,offset str_dw2h_2
			call	mmx_dw2hexA
		counter_end
		print str$(eax)," clocks",09,"- mmx_dw2hexA x2 (proc)",10,13
		
		counter_begin loop_count,HIGH_PRIORITY_CLASS
			m_mmx_dw2hex	01234568h, offset str_dw2h_1
			m_mmx_dw2hex	9ABCDEF0h, offset str_dw2h_2
		counter_end
		print str$(eax)," clocks",09,"- m_mmx_dw2hex x2 (macro)",10,13
		
		counter_begin loop_count,HIGH_PRIORITY_CLASS
			m_mmx_dw2hex	01234568h, offset str_dw2h_1
		counter_end
		print str$(eax)," clocks",09,"- m_mmx_dw2hex x1 (macro)",10,13,10,13
		
		
		counter_begin loop_count,HIGH_PRIORITY_CLASS
			push	offset str_dw2h_1
			push	01234568h
			call 	dw2hex_ex
			push	offset str_dw2h_2
			push	9ABCDEF0h
			call 	dw2hex_ex
		counter_end
		print str$(eax)," clocks",09,"- dw2hex_ex x2",10,13
		
		counter_begin loop_count,HIGH_PRIORITY_CLASS
			push	offset str_dw2h_1
			push	01234568h
			call 	dw2hex_ex
		counter_end
		print str$(eax)," clocks",09,"- dw2hex_ex x1",10,13,10,13
		
		print "press any key to continue..."
		getkey
		xor		eax,eax
	pop		ebp
	retn
end start